' Copyright 2009 Ivan Krivyakov
'
'   Licensed under the Apache License, Version 2.0 (the "License")
'   you may not use this file except in compliance with the License.
'   You may obtain a copy of the License at
'
'       http://www.apache.org/licenses/LICENSE-2.0
'
'   Unless required by applicable law or agreed to in writing, software
'   distributed under the License is distributed on an "AS IS" BASIS,
'   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
'   See the License for the specific language governing permissions and
'   limitations under the License.
' 

Namespace Ikriv.Surfaces
	Public Class PropertyHolder(Of PropertyType, HoldingType As DependencyObject)
		Private _property As DependencyProperty

		Public Sub New(ByVal name As String, ByVal defaultValue As PropertyType, ByVal propertyChangedCallback As PropertyChangedCallback)
			_property = DependencyProperty.Register(name, GetType(PropertyType), GetType(HoldingType), New PropertyMetadata(defaultValue, propertyChangedCallback))
		End Sub

        Public ReadOnly Property [Property]() As DependencyProperty
            Get
                Return _property
            End Get
        End Property

        Public Function [Get](ByVal obj As HoldingType) As PropertyType
            Return CType(obj.GetValue(_property), PropertyType)
        End Function

        Public Sub [Set](ByVal obj As HoldingType, ByVal value As PropertyType)
            obj.SetValue(_property, value)
        End Sub
    End Class
End Namespace
