' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Imports IKriv.WpfHost.Interfaces

Namespace UseLogService
	Friend Class Plugin
		Inherits PluginBase
		Implements IUnsavedData

		Private ReadOnly _log As ILog
		Private ReadOnly _parameter As String
		Private _control As MainUserControl

		Public Sub New(ByVal host As IWpfHost)
			_log = host.GetService(Of ILog)()
			Dim startupInfo = host.GetService(Of PluginStartupInfo)()
			If startupInfo IsNot Nothing Then
				_parameter = startupInfo.Parameters
			End If
		End Sub

		Public Overrides Function CreateControl() As FrameworkElement
			_control = New MainUserControl With {.Log = _log}
			_control.Message.Text = _parameter
			Return _control
		End Function

        Public Function GetNamesOfUnsavedItems() As String() Implements IUnsavedData.GetNamesOfUnsavedItems
            If _control Is Nothing Then
                Return Nothing
            End If
            Return _control.GetNamesOfUnsavedItems
        End Function
	End Class
End Namespace
