' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Imports System.Reflection
Imports IKriv.WpfHost.Interfaces

Namespace IKriv.PluginHosting
	Friend Class AssemblyResolver
		Private _thisAssemblyName As String
		Private _interfacesAssemblyName As String

        Public Sub Setup()
            AddHandler AppDomain.CurrentDomain.AssemblyResolve, AddressOf OnAssemblyResolve
            _thisAssemblyName = Me.GetType.Assembly.GetName.Name
            _interfacesAssemblyName = GetType(IWpfHost).Assembly.GetName.Name
        End Sub

		Private Function OnAssemblyResolve(ByVal sender As Object, ByVal args As ResolveEventArgs) As System.Reflection.Assembly
			Dim name = New AssemblyName(args.Name)

			If name.Name = _thisAssemblyName Then
				Return Me.GetType.Assembly
			End If
			If name.Name = _interfacesAssemblyName Then
				Return GetType(IWpfHost).Assembly
			End If

			Return Nothing
		End Function
	End Class
End Namespace
