' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Namespace IKriv.PluginHosting
	Public Class ExceptionUtil
		Public Shared Function GetUserMessage(ByVal ex As Exception) As String
			Return String.Join(vbCrLf, GetInnerExceptions(ex).Select(Function(e) String.Format("{0}: {1}", e.GetType.Name, e.Message)).ToArray)
		End Function

		Private Shared Function GetInnerExceptions(ByVal ex As Exception) As IEnumerable(Of Exception)
            Dim returnval As New List(Of Exception)
            Dim exception = ex
			Do While exception IsNot Nothing
                returnval.Add(exception)
				exception = exception.InnerException
            Loop
            Return returnval
		End Function
	End Class
End Namespace
