' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Imports System.Collections
Imports System.Runtime.Remoting.Channels
Imports System.Runtime.Remoting.Channels.Ipc
Imports System.Runtime.Serialization.Formatters

Namespace IKriv.PluginHosting
	Public Class IpcServices
		Public Shared Registered As Boolean
		Public Shared Mutex As New Object

		Public Shared Sub RegisterChannel(ByVal portName As String)
			SyncLock Mutex
				If Registered Then
					Exit Sub
				End If

				Dim serverProvider = New BinaryServerFormatterSinkProvider With {.TypeFilterLevel = TypeFilterLevel.Full}
				Dim clientProvider = New BinaryClientFormatterSinkProvider
				Dim properties = New Hashtable
				properties("portName") = portName

				Dim channel = New IpcChannel(properties, clientProvider, serverProvider)
				ChannelServices.RegisterChannel(channel, False)
				Registered = True
			End SyncLock
		End Sub
	End Class
End Namespace
