' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Imports System.AddIn.Contract

Namespace IKriv.PluginHosting
	Friend Class NativeHandleContractInsulator
		Inherits MarshalByRefObject
		Implements INativeHandleContract

		Private ReadOnly _source As INativeHandleContract

		Public Sub New(ByVal source As INativeHandleContract)
			_source = source
		End Sub

		Public Function GetHandle() As IntPtr Implements INativeHandleContract.GetHandle
			Return _source.GetHandle
		End Function

		Public Function AcquireLifetimeToken() As Integer Implements AddIn.Contract.IContract.AcquireLifetimeToken
			Return _source.AcquireLifetimeToken
		End Function

		Public Function GetRemoteHashCode() As Integer Implements AddIn.Contract.IContract.GetRemoteHashCode
			Return _source.GetRemoteHashCode
		End Function

		Public Function QueryContract(ByVal contractIdentifier As String) As IContract Implements AddIn.Contract.IContract.QueryContract
			Return _source.QueryContract(contractIdentifier)
		End Function

		Public Function RemoteEquals(ByVal contract As IContract) As Boolean Implements AddIn.Contract.IContract.RemoteEquals
			Return _source.RemoteEquals(contract)
		End Function

		Public Function RemoteToString() As String Implements AddIn.Contract.IContract.RemoteToString
			Return _source.RemoteToString
		End Function

		Public Sub RevokeLifetimeToken(ByVal token As Integer) Implements AddIn.Contract.IContract.RevokeLifetimeToken
			_source.RevokeLifetimeToken(token)
		End Sub

		Public Overrides Function InitializeLifetimeService() As Object
			Return Nothing ' live forever
		End Function
	End Class
End Namespace
