' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Imports System.AddIn.Contract
Imports System.AddIn.Pipeline
Imports IKriv.WpfHost.Interfaces

Namespace IKriv.PluginHosting
	Friend Class RemotePlugin
		Inherits MarshalByRefObject
		Implements IRemotePlugin

		Private ReadOnly _plugin As IPlugin

		Public Sub New(ByVal plugin As IPlugin)
			_plugin = plugin
			Dim control = plugin.CreateControl
			Dim localContract = FrameworkElementAdapters.ViewToContractAdapter(control)
			Contract = New NativeHandleContractInsulator(localContract)
		End Sub

		Private privateContract As INativeHandleContract
        Public Property Contract As INativeHandleContract Implements IRemotePlugin.Contract
            Get
                Return privateContract
            End Get
            Private Set(ByVal value As INativeHandleContract)
                privateContract = value
            End Set
        End Property

		Public Function GetService(ByVal serviceType As Type) As Object Implements IServiceProvider.GetService
			Return _plugin.GetService(serviceType)
		End Function

		Public Sub Dispose() Implements IDisposable.Dispose
			_plugin.Dispose()
		End Sub

		Public Overrides Function InitializeLifetimeService() As Object
			Return Nothing ' live forever
		End Function
	End Class
End Namespace
