' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Namespace IKriv.WpfHost.Interfaces
	''' <summary>
	''' Recommended (but not requried) base class for user-defined plugins
	''' </summary>
	Public MustInherit Class PluginBase
		Inherits MarshalByRefObject
		Implements IPlugin

		Public MustOverride Function CreateControl() As FrameworkElement Implements IPlugin.CreateControl

		Public Overridable Function GetService(ByVal serviceType As Type) As Object Implements IServiceProvider.GetService
			If serviceType.IsAssignableFrom(Me.GetType) Then
				Return Me
			End If
			Return Nothing
		End Function

		Public Overridable Sub Dispose() Implements IDisposable.Dispose
		End Sub

		Public Overrides Function InitializeLifetimeService() As Object
			Return Nothing ' live forever
		End Function
	End Class
End Namespace
