' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Imports System.IO
Imports System.Xml.Serialization

Namespace IKriv.WpfHost.Catalogs
	Public Class XmlPluginCatalog
		Implements IPluginCatalog

		<XmlRoot(ElementName:="PluginCatalog", Namespace:="http://www.ikriv.com/wpfHosting/plugins")>
		Public Class XmlPluginData
			<XmlArrayItem(ElementName := "Plugin")>
			Public Property Plugins As PluginCatalogEntry()
		End Class

		Public Sub New()
		End Sub

		Public Sub New(ByVal fileName As String)
			Me.FileName = fileName
		End Sub

		Public Property FileName As String

		Public Function GetPluginList() As IEnumerable(Of PluginCatalogEntry) Implements IPluginCatalog.GetPluginList
			Using reader = New StreamReader(FileName)
				Dim serializer = New XmlSerializer(GetType(XmlPluginData))
				Dim data = CType(serializer.Deserialize(reader), XmlPluginData)
				Return data.Plugins
			End Using
		End Function
	End Class
End Namespace
