' Copyright (c) 2013 Ivan Krivyakov
' Licensed under the Apache License, Version 2.0 (the "License")
' you may not use this file except in compliance with the License.
' You may obtain a copy of the License at
' http://www.apache.org/licenses/LICENSE-2.0
'

Imports IKriv.WpfHost.Interfaces
Imports Microsoft.Practices.Unity

Namespace IKriv.WpfHost
	Friend Class PluginViewOfHost
		Inherits MarshalByRefObject
		Implements IWpfHost

		Private ReadOnly _container As IUnityContainer

		Public Sub New(ByVal container As IUnityContainer)
			_container = container
		End Sub

        Public Sub ReportFatalError(ByVal userMessage As String, ByVal fullExceptionText As String) Implements IWpfHost.ReportFatalError
            LastError = New PluginException(userMessage, fullExceptionText)
            RaiseEvent FatalError(LastError)
        End Sub

        Public ReadOnly Property HostProcessId As Integer Implements IWpfHost.HostProcessId
            Get
                Return Process.GetCurrentProcess.Id
            End Get
        End Property

        Public Function GetService(ByVal serviceType As Type) As Object Implements IServiceProvider.GetService
            Return _container.Resolve(serviceType)
        End Function

		Public Event FatalError As Action(Of Exception)

        Private PrivateLastError As Exception
		Public Property LastError As Exception
			Get
                Return PrivateLastError
			End Get
			Private Set(ByVal value As Exception)
                PrivateLastError = value
			End Set
		End Property

		Public Overrides Function InitializeLifetimeService() As Object
			Return Nothing ' live forever
		End Function
	End Class
End Namespace
